#ifdef WIN32
#pragma warning(disable : 4786 )
#endif
#include "CSHelper.h"

//! string to number (with given radix)
int CSHelper::convert(const char* start_string, int radix)
{
	char* string;
	char *pointer;
	int value=0;
	int tmp=0;
	int multiplier;
	int loop;
	int exponent=0;
	if ((start_string==0)||(radix==0))
	{
		return 0;
	}
	pointer=string=strdup(start_string); /* don't destroy start string */

	/* make the string entirely uppercase */

	while (*pointer!=(char)0)
	{
		if ((*pointer>='a')&&(*pointer<='z'))
		{
			*pointer+=('A'-'a');
		}
		pointer++;
	}
	
	/* decode the string backwards */
	pointer = string;
	while (*(pointer+1)!=0)
	{
		pointer++;
	}
	
	do
	{
		tmp=*pointer;
		if (tmp>'9')
		{
			tmp-=('A'-10);
		}
		else
		{
			tmp-='0';
		}
		/* Test for validity */
		if (tmp>=radix)
		{
			free(string);
			return 0;
		}

		/* Calculate the Multiplier */
		multiplier=1;
		for (loop=0;loop<exponent;loop++)
		{
			multiplier*=radix;
		}
		value+=tmp*multiplier;

		/* Increment the exponent */
		exponent++;
	}
	while(pointer--!=string);

	free(string);
	return value;
}

// replace wo, was, womit
bool CSHelper::replace(std::string &text, const std::string &oldValue, const std::string &newValue)
{
	std::string newText;
	std::string rest;
	int posStart = strstr(text.c_str(), oldValue.c_str()) - text.c_str();
	if (posStart != -(int) (text.c_str()))
	{
		newText = text.substr(0, posStart);
	}
	else
	{
		return false;
	}
	newText = newText + newValue;
	
	int len = oldValue.size();
	if (posStart+len < text.size())
	{
		newText = newText + text.substr(posStart + len, text.size() - (posStart + len) );
	}
	text = newText;
	return true;
}

//! Gives the percentage of the color. Each r ,g ,b value is calculated as percentage
//! \param color in RGB lile 0x102030 (r = 0x10, g = 0x20, b = 0x30)
//! \param percent percentage
//! \return percent of the color in RGB, as above
int CSHelper::colorPercent(int color, int percent)
{
	int r = (((color)&0xff0000)>>16);
	int g = (((color)&0x00ff00)>>8);
	int b = (((color)&0x0000ff));
	int colorPercent;
	colorPercent =  (((r*percent)/100)<<16);
	colorPercent += (((g*percent)/100)<<8);
	colorPercent += ( (b*percent)/100);
	return colorPercent;
}

