#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "CSMessageDispatchable.h"
#include "CSMessageListener.h"
#include "CSMessage.h"

const char *CSMessageDispatchable::CLASS = "CSMessageDispatchable";


std::string ListenerInterested::getType() 
{
	return mListener->getType();
}

void CSMessageDispatchable::sendMessage(CSMessage &message)
{
	static char *functionName="sendMessage";
	static int SEQUENCE = 0;
	SEQUENCE++;
	int sequence = SEQUENCE;
	// saftey meassure. if a listener is removed while sending!
	ListenerInteresteds::iterator iter = mListeners.begin();
	while (iter != mListeners.end())
	{
		ListenerInterested *listenerInterested = *iter;
		
		// Abfrage auf kleiner, weil innerhalb eines events andere events ausgelst werden knnen
		// da nur eine Sequenznummer pro listener gehalten wird
		// hier die Abrage auf kleiner
		// Mglicher Weise kann das zu komplikationen fhren, wenn ein Listener
		// auf verschiedene Events wartet, die voneinander abhngen > BEOBACHTEN!
		if (listenerInterested->mLastSentMessageSequence < sequence)
		{
			listenerInterested->mLastSentMessageSequence = sequence;
			if ((listenerInterested->mInterestedIn == -1 ) || (listenerInterested->mInterestedIn == message.getType()))
			{
				// todo! 
				// something to make sure, that a message is not sent twice to the same listener!
				mActive = true;
//printf("preEventSend: %s\n", listenerInterested->getType().c_str() ); flushall();
				listenerInterested->mListener->dispatchMessage(&message);
//printf("postEventSend\n"); flushall();
				mActive = false;
//CSMessageDispatchable kann deleted sein! -> bel!
//der fall bei event auf label, welches eine neue HTMLSeite als Link erzeugt

/* TODO
Lsung:
CSMessageDispatchable wird nicht vererbt, sondern agregiert -> und das statisch!
Es gibt insgesamt nur einen einzigen Dispatcher!
wurde noch nicht implementiert -> workaround ist setPageLater in HTMLPanel!
*/
				iter = mListeners.begin();	// reset to make sure the vector is still valid!
											// listener might be removed while processing event!
				continue;
			}
		}
		iter++;
	}
}

void CSMessageDispatchable::addMessageListener(CSMessageListener* listener, int typeOfMessage)
{
	static char *functionName="addMessageListener";
	LOG_ENTER 
	// savety meassure, not to add twice!
	removeMessageListener(listener, typeOfMessage);
	ListenerInterested *listenerInterested = new ListenerInterested(listener, typeOfMessage);
	mListeners.push_back(listenerInterested);
	LOG_EXIT
}

int CSMessageDispatchable::removeMessageListener(CSMessageListener* listener)
{
	static char *functionName="removeMessageListener";
	LOG_ENTER 
	int count = 0;
	ListenerInteresteds::iterator iter = mListeners.begin();
	while ( iter != mListeners.end())
	{
		ListenerInterested *listenerNotInterested = (*iter);
		if (listenerNotInterested->mListener == listener)
		{
			mListeners.erase(iter);
			delete (listenerNotInterested);
			iter = mListeners.begin();	// restart!
			count++;
		}
		else
		{
			iter++;
		}
	}

	// TODO: ensure, that the listener is not currently enqueued with
	//       a waiting message!
	LOG_EXIT
	return count;
}

int CSMessageDispatchable::removeMessageListener(CSMessageListener* listener, int typeOfMessage)
{
	static char *functionName="removeMessageListener";
	LOG_ENTER 
	int count = 0;
	ListenerInteresteds::iterator iter = mListeners.begin();
	while ( iter != mListeners.end())
	{
		ListenerInterested *listenerInterested = *iter;
		if ((listenerInterested->mInterestedIn == typeOfMessage)
			&& ( listenerInterested->mListener == listener))
		{
			mListeners.erase(iter);
			delete (listenerInterested);
			iter = mListeners.begin();
			count++;
		}
		else
		{
			iter++;
		}
	}
	// TODO: ensure, that the listener is not currently enqueued with
	//       a waiting message!
	LOG_EXIT
	return count;
}
