#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "CSMessageListener.h"
#include "CSMessage.h"

CSInternalMessages CSMessageListener::mCSInternalMessages;
const char *CSMessageListener::CLASS = "CSMessageListener";

CSMessageListener::CSMessageListener()
{
	static char *functionName="CSMessageListener";
	LOG_ENTER 
	LOG_EXIT
}

CSMessageListener::~CSMessageListener()
{
	static char *functionName="CSMessageListener";
	LOG_ENTER 
	LOG_EXIT
}

void CSMessageListener::addMessageToQueue(CSMessageListener *listener, CSMessage *message)
{
	static char *functionName="addMessageToQueue";
	if (listener == 0)
	{
		return;
	}
	
	CSInternalMessage *iMessage = new CSInternalMessage();
	iMessage->listener = listener;			
	iMessage->message = message;
	mCSInternalMessages.push_back(iMessage);
}

void CSMessageListener::dispatchQueuedMessages()
{
	static char *functionName="dispatchQueuedMessages";
	CSInternalMessages::iterator iter;
	for (iter = mCSInternalMessages.begin(); iter != mCSInternalMessages.end(); iter++)
	{
		CSInternalMessage *iMessage = *iter;
		iMessage->listener->reactOnMessage(iMessage->message);
		delete(iMessage);
	}
	mCSInternalMessages.clear();
}

void CSMessageListener::dispatchMessage(CSMessage *message)
{
	static char *functionName="dispatchMessage";
	if (!message->isDispatchAtOnce())
	{
		addMessageToQueue(this, message);
		return;
	}
	reactOnMessage(message);
}
