#ifndef CSXMLHelperTinyXPath_H
#define CSXMLHelperTinyXPath_H

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "CSLog.h"
#include <string>
#include <iostream.h>

#include "tinyxml.h"
#include "tinystr.h"
#include "tinyxpstream.h"

#include "xmlutil.h"
#include "workitem.h"
#include "workstack.h"
#include "xpathappl.h"

class CSXMLHelper
{
	private:
			std::string mErrorMessageString;
			TiXmlDocument					*mXMLdoc;
			TiXmlElement					*mXMLsource;
			
			int								mError;

			XObjectPtr getXPathResult(const std::string &xpath);
			std::string toAscii(const XObjectPtr &xObjectPtr);
			std::string toAscii(const XalanDOMString &xmlString);
			std::string toAscii(const XalanDOMString::CharVectorType &charVec);
			std::string toAscii(const DOMString &domString);
			std::string toAscii(const XMLCh* xmlChars);

	public:
		CSXMLHelper(const std::string &xmlFilename, const std::string &contextNode);
		virtual ~CSXMLHelper();
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}

		int getError(void);
		std::string getErrorMessage(void);
		int getInt(const std::string &xpath);
		std::string getString(const std::string &xpath);

		// -----------------------------------------------
		//  Implementation of the error handler interface
		// -----------------------------------------------
		void warning(const SAXParseException& toCatch);
		void error(const SAXParseException& toCatch);
		void fatalError(const SAXParseException& toCatch);
		void resetErrors();
};

#endif CSXMLHelperTinyXPath_H