#ifndef CSXMLHelperXalan_H
#define CSXMLHelperXalan_H

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "CSLog.h"
#include <string>
#include <iostream.h>

#include <util/XercesDefs.hpp>
#include <sax/ErrorHandler.hpp>
#include <sax/SAXParseException.hpp>

#include <XalanDOM/XalanDOMString.hpp>

class XalanSourceTreeInit;
class XalanSourceTreeDOMSupport;
class XalanSourceTreeParserLiaison;
class XalanNode;
class XPathEvaluator;
class XalanDocument;
class XObjectPtr;

class XObjectPtr;
class XalanDOMString;
class DOMString;

class CSXMLHelper : public ErrorHandler
{
	private:
			std::string mErrorMessageString;

			XalanSourceTreeInit				*theSourceTreeInit;
			XalanSourceTreeDOMSupport		*theDOMSupport;
			XalanSourceTreeParserLiaison	*theLiaison;
			XalanNode						*theContextNode;
			XPathEvaluator					*theEvaluator;
			XalanDocument					*theDocument;
			int								mError;
			int								mInit;
			static int						mLock;

			XObjectPtr getXPathResult(const std::string &xpath);
			std::string toAscii(const XObjectPtr &xObjectPtr);
			std::string toAscii(const XalanDOMString &xmlString);
			std::string toAscii(const XalanDOMString::CharVectorType &charVec);
			std::string toAscii(const DOMString &domString);
			std::string toAscii(const XMLCh* xmlChars);

	public:
		CSXMLHelper(const std::string &xmlFilename, const std::string &contextNode);
		virtual ~CSXMLHelper();
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}

		int getError(void);
		std::string getErrorMessage(void);
		int getInt(const std::string &xpath);
		std::string getString(const std::string &xpath);

		// -----------------------------------------------
		//  Implementation of the error handler interface
		// -----------------------------------------------
		void warning(const SAXParseException& toCatch);
		void error(const SAXParseException& toCatch);
		void fatalError(const SAXParseException& toCatch);
		void resetErrors();
};

#endif CSXMLHelperXalan_H