#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "CSGrafikElement.h"
#include "CSArea.h"
#include "CSPicture.h"
#include "CSLAF.h"
#include "CSHelper.h"

const char *CSArea::CLASS = "CSArea";
const char *CSRoundedArea::CLASS = "CSRoundedArea";
const char *CSGradientArea::CLASS = "CSGradientArea";
const char *CSPictureArea::CLASS = "CSPictureArea";

//! \todo gradient areas, picture (background areas, strechted ord centered) rounded corner areas
//! none of should be difficult!

CSArea::CSArea()
{
	static char *functionName="CSArea";
	LOG_ENTER 
	mColor = 0;
	LOG_EXIT
}

void CSArea::paint(SDL_Surface *destination, SDL_Rect *area)
{
	static char *functionName="paint";
/*
	// simple shading!	
	SDL_Rect areaCopy;
	for (int i= 0; i<=area->h; i++)
	{
		areaCopy = *area;
		areaCopy.y += i;
		areaCopy.h = 1;
		SDL_FillRect(destination, &areaCopy, CSHelper::colorPercent(mColor, 50+50*i/area->h));

	}

*/
	SDL_FillRect(destination, area, mColor);
}

CSRoundedArea::CSRoundedArea()
{
	static char *functionName="CSRoundedArea";
	LOG_ENTER 
	mCorner = 4;
	LOG_EXIT
}

void CSRoundedArea::paint(SDL_Surface *destination, SDL_Rect *area)
{
	static char *functionName="paint";
	SDLMain::DrawRoundRectFill(destination, area->x, area->y, area->w, area->h, mColor, mCorner);
}

CSGradientArea::CSGradientArea()
{
	static char *functionName="CSRoundedArea";
	LOG_ENTER 
	mType = TYPE_HORIZONTAL;
	mSecondColor = 0;
	LOG_EXIT
}

void CSGradientArea::paint(SDL_Surface *destination, SDL_Rect *area)
{
	static char *functionName="paint";
	if (mType == TYPE_HORIZONTAL)
	{
		SDLMain::horizgradient(destination, *area, mColor, mSecondColor, 255);
		return;
	}
	SDLMain::vertgradient(destination, *area, mColor, mSecondColor, 255);
}

CSPictureArea::CSPictureArea()
{
	static char *functionName="CSRoundedArea";
	LOG_ENTER 
	mStretched = true;
	mCentered = true;
	mPicture = 0;
	LOG_EXIT
}

void CSPictureArea::paint(SDL_Surface *destination, SDL_Rect *area)
{
	static char *functionName="paint";
	if (mPicture == 0)
	{
		SDL_FillRect(destination, area, mColor);
	}
	if (mStretched)
	{
		SDL_Surface *pic = mPicture->getScaledPicture(area->w, area->h);
		if (pic)
		{
			if (SDL_BlitSurface(pic, 0, destination, area)< 0)
			{
				SDLMain::shutdown((std::string)"BlitSurface error: " + SDL_GetError(), 1);
			}
			
			return;
		}
	}
	if (mCentered)
	{
		int x = area->w/2 - mPicture->getWidth()/2;
		int y = area->h - mPicture->getHeight()/2;
		mPicture->display(destination, x, y);
		return;
	}
	mPicture->display(destination, area->x, area->y);
}
