#ifndef CSArea_h
#define CSArea_h

// USES SDL_Surface

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <string>

#include "SDLMain.h"
#include "CSLog.h"

class CSArea;
class CSPicture;
typedef std::vector<CSArea *> CSAreas;

class CSArea
{
	private:
	protected:
		int mColor;

	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		CSArea();
		CSArea(int color){mColor = color;}
		virtual ~CSArea() {}
		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		void setColor(int color){mColor = color;}
};

class CSRoundedArea : public CSArea
{
	private:
	protected:
		int mCorner;

	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		CSRoundedArea();
		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		void setCorner(int corner){mCorner = corner;}
};

class CSGradientArea : public CSArea
{
	private:
	protected:
		int mType;
		int mSecondColor;

	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		CSGradientArea();
		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		void setType(int type){mType = type;}
		void setSecondColor(int color){mSecondColor = color;}
};

class CSPictureArea : public CSArea
{
	private:
	protected:
		bool mStretched;
		bool mCentered;
		CSPicture *mPicture;

	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		CSPictureArea();
		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		void setPicture(CSPicture *picture){mPicture = picture;}
		void setCentered(bool centered){mCentered = centered;}
		void setStretched(bool stretched){mStretched = stretched;}
};
#endif // CSArea_h
