#ifndef CSBorder_h
#define CSBorder_h

// USES SDL_Surface

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <string>

#include "SDLMain.h"
#include "CSLog.h"

class CSBorder;
typedef std::vector<CSBorder *> CSBorders;

const int BORDER_TYPE_NONE = 0;
const int BORDER_TYPE_DOUBLE = 1;
const int BORDER_TYPE_UP = 2;
const int BORDER_TYPE_INTER = 4;
const int BORDER_TYPE_SINGLE_COLOR = 8;
const int BORDER_TYPE_HOVER = 16;

const int BORDER_TYPE_SELECTED =	BORDER_TYPE_DOUBLE + BORDER_TYPE_UP + BORDER_TYPE_SINGLE_COLOR;
const int BORDER_TYPE_WINDOW =		BORDER_TYPE_DOUBLE + BORDER_TYPE_UP;
const int BORDER_TYPE_BUTTON =		BORDER_TYPE_DOUBLE + BORDER_TYPE_UP;
const int BORDER_TYPE_CHECK_BUTTON= BORDER_TYPE_DOUBLE;
const int BORDER_TYPE_TEXTFIELD =	BORDER_TYPE_DOUBLE;
const int BORDER_TYPE_MENU =		BORDER_TYPE_UP + BORDER_TYPE_HOVER;

class CSBorder
{
	private:
	protected:
		int mType;
		int mState;
		int mBorderOuterEdgeWidth;
		int mBorderInnerEdgeWidth;
		int mBorderInterEdgeWidth;

		int mShadeBright;
		int mShadeBrighter;
		int mShadeDark;
		int mShadeDarker;
		CSBorder();

	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		virtual ~CSBorder() {}
		static CSBorder *getBorder(int type);
		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		virtual void setType(int type) {mType = type;}
		virtual void setState(int state) {mState = state;}
		virtual int getTotalWidth();
		virtual int getTotalHeight();

		virtual int getSizeSouth();
		virtual int getSizeNorth();
		virtual int getSizeEast();
		virtual int getSizeWest();
};

class CSRoundedBorder : public CSBorder
{
	private:
	protected:
		int mCorner;
		CSRoundedBorder() 
		{
			mCorner = 0;
		}

	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		virtual ~CSRoundedBorder() {}
		static CSRoundedBorder *getBorder(int type);
		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		virtual void setCorner(int corner) {mCorner = corner;}
};
#endif // CSBorder_h
