#ifndef CSButton_h
#define CSButton_h

// USES SDL_Surface

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>

#include "CSGrafikElement.h"
#include "CSIcon.h"
#include "CSMessage.h"
#include "CSLog.h"
#include "CSBorder.h"


class CSButton;
typedef std::vector<CSButton *> CSButtons;

class CSButton : public CSGrafikElement
{
	private:
		void initButton();
	protected:
		CSIcon *mIcon;
		GuiMessage MESSAGE_BUTTON_PRESSED;
		GuiMessage MESSAGE_BUTTON_RELEASED;
		void layoutSetupButton();

	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}

		CSButton(CSIcon *icon); // Button frees Icon!
		CSButton(const std::string &text); 
		virtual ~CSButton();
		void reactOnMessageButton(CSMessage *message);
		virtual void reactOnMessage(CSMessage *message);
		virtual void layoutSetup() {layoutSetupButton();}
		virtual int getButtonState() {return mBorderState;}
};

class CSDragButton : public CSButton
{
	private:
		GuiMessage MESSAGE_BUTTON_DRAGGED;
		bool mDragging;
		int mDragStartX;
		int mDragStartY;
	protected:
	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		CSDragButton(CSIcon *icon); // Button frees Icon!
		void reactOnMessageDragButton(CSMessage *message);
		virtual void reactOnMessage(CSMessage *message);
};

#endif // CSButton_h
