#ifndef CSCombobox_h
#define CSCombobox_h

// USES SDL_Surface

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>

#include "CSGrafikElement.h"
#include "CSMessage.h"
#include "CSLog.h"
#include "CSStringlist.h"

class CSCombobox;
class CSTextfield;
class CSButton;
class CSListbox;
typedef std::vector<CSCombobox *> CSComboboxs;

class CSCombobox : public CSGrafikElement
{
	private:
		std::string mString;
		std::string mWorkingString;
		float mTickTimeNext;
		float mCursorRate;
		bool mCursorShown;

CSInset mComboBoxInset;	// Insert of "Textfield" from mInsert

		CSTextfield *mTextfield;
		CSButton *mMore;
		CSListbox *mListbox;
		bool mListboxActive;
		bool mIsEditable;
		bool mIsEditing;
		int mTextOffset;

		void init(const std::string &text);
		void setListActive(bool active);


	protected:
		GuiMessage MESSAGE_COMBOBOX_ITEM_SELECTED;
		void layoutSetupCombobox();
		void rebuildElement();

	public:
		CSCombobox(int witdh);
		virtual ~CSCombobox();
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		
		void reactOnMessageCombobox(CSMessage *message);
		virtual void reactOnMessage(CSMessage *message);

		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		virtual void putString(SDL_Surface *destination, SDL_Rect *parentViewport, int x1, int y1, const std::string &string);
		virtual void setItems(const CSStringlist &list);
		virtual CSStringlist getItems();
		virtual std::string getSelectedString();
		virtual void setEditable(bool e) {mIsEditable = e;}
		virtual void *getSelectedObject();
		virtual void setSelected(const std::string &text) {mString = text;}
		virtual void setSelected(int i);
		virtual void layoutSetup() {layoutSetupCombobox();}
};

#endif // CSCombobox_h
