#ifndef CSHTMLPanel_h
#define CSHTMLPanel_h

// USES SDL_Surface

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>
#include <map>
#include "CSTypes.h"

#include "CSGrafikElement.h"
#include "CSLog.h"
#include "CSTypes.h"
#include "CSStringlist.h"
#include "CSIcon.h"
#include "CSHTMLHelper.h"
#include "CSPicture.h"
#include "CSMessageListener.h"
#include "CSMessageBox.h"
#include "CSHTMLElement.h"

class CSHTMLPanel;

typedef std::vector<CSHTMLPanel *> CSHTMLPanels;

class CSHTMLPanel : public CSGrafikElement
{
	private:
		CSMessageBox *mMessageBox;
		CSHTMLElements mHTMLElements;
		CSHTMLHelper *mHelper;
		
		int mBackgroundColor;
		std::string mFilename;
		std::string mBaseDirectory;
		std::string mAnker;

		bool mSetPageLater;
		bool mPageKickoff;
		std::string mSetPageLaterName;
		void deleteOldPage();
		void getHTMLSize(int &w, int &h);
		void initHTMLPanel();
		int mHTMLHeightInPixel;
		int mHTMLWidthInPixel;

		std::string getBaseDirectory(const std::string &filename);
		std::string extractAnker(std::string &filename);
		void startAtAnker(const std::string &anker);
		int getBackgroundColorHTML();

	protected:
		virtual void layoutSetupHTMLPanel();
		virtual void rebuildElement();

	public:
		CSHTMLPanel(int height, int width, const std::string &filename);
		virtual ~CSHTMLPanel();
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}

		virtual void setPage(const std::string &filename, bool now);
		
		void reactOnMessageHTMLPanel(CSMessage *message);
		virtual void reactOnMessage(CSMessage *message);

		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		virtual void layoutSetup(){layoutSetupHTMLPanel();}
};

#endif // CSHTMLPanel_h
