#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "CSLabel.h"
#include "CSBorder.h"
#include "CSFont.h"
#include "CSLAF.h"
#include "CSInset.h"

const char *CSLabel::CLASS = "CSLabel";

CSLabel::CSLabel() : CSGrafikElement(0, 0)
{
	static char *functionName="CSLabel";
	LOG_ENTER 
	mString = "";
	LOG_EXIT
}

CSLabel::CSLabel(const std::string &string) : CSGrafikElement(0, 0)
{
	static char *functionName="CSLabel";
	LOG_ENTER 
	mString = string;
	LOG_EXIT
}

void CSLabel::paint(SDL_Surface *destination, SDL_Rect *parentViewport)
{
	static char *functionName="paint";
	SDL_Rect elementArea = getElementArea();
	elementArea.x += parentViewport->x;
	elementArea.y += parentViewport->y;
	putString(destination, &elementArea, 
		getBorder()->getSizeWest() + getInsetInternal()->getSizeWest(), 
		getBorder()->getSizeNorth()  + getInsetInternal()->getSizeNorth(), 
		getTextColor(), mString.c_str());
}

void CSLabel::layoutSetupLabel()
{
	static char *functionName="layoutSetupLabel";
	LOG_ENTER 
	mMinHeight = getFont()->getHeight();
	mMinWidth = getFont()->getWidth(mString.c_str());
	mHeight = mMinHeight + getBorder()->getTotalHeight() + getInset().getTotalHeight();
	mWidth = mMinWidth + getBorder()->getTotalWidth() + getInset().getTotalWidth();
	LOG_EXIT
}
