#ifndef CSLabel_h
#define CSLabel_h

// USES SDL_Surface

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>

#include "CSGrafikElement.h"
#include "CSLog.h"

class CSLabel;
typedef std::vector<CSLabel *> CSLabels;

class CSLabel : public CSGrafikElement
{
	private:
		std::string mString;
	protected:
		virtual void layoutSetupLabel();
	public:
		CSLabel();
		CSLabel(const std::string &string);
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}

		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		virtual bool isFocusable() {return false;}
		virtual void setText(const std::string &t) {mString = t; layoutChanged();}
		virtual void layoutSetup() {layoutSetupLabel();}
};

#endif // CSLabel_h
