#ifndef CSListbox_h
#define CSListbox_h

// USES SDL_Surface
// USES SDL_Rect 

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>

#include "CSMessage.h"
#include "CSGrafikElement.h"
#include "CSScrollbar.h"
#include "CSLog.h"
#include "CSStringlist.h"

#include "CSIcon.h"

class CSListbox;

class CSListbox : public CSGrafikElement
{
	private:
		//void paintArea(SDL_Surface *destination, SDL_Rect *parentViewport);
		// void paintBorder(SDL_Surface *destination, SDL_Rect *parentViewport);
		CSStringlist mItems;
		CSScrollbar *mScrollbar;
		CSBorder *mSelectionBorder;

		int mNumberOfElementsDisplayed;
		int mSelectedItem;
		int mStart;
		int mEnd;
		int mDisplayLength;		// maximal displayable items in viewport (without scrolling)
		int mHoverSelection;
		CSInset mListInset;		// Insert of Text from "mInsert"

	protected:
		GuiMessage MESSAGE_LIST_ITEM_SELECTED;
		void layoutSetupListbox();
		virtual void rebuildElement();

	public:
		CSListbox(int numberOfElementsDisplayed, int width);
		virtual ~CSListbox();
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}

		void initListbox();
		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		void reactOnMessageListbox(CSMessage *message);
		virtual void reactOnMessage(CSMessage *message);
		virtual void setGrafikCursor(int x, int y);
		virtual void setItems(const CSStringlist &list) 
		{
			mItems = list;
			layoutChanged();
		}
		virtual CSStringlist getItems() {return mItems;}
		virtual int getSelected() {return mSelectedItem;}
		virtual void setSelected(int i);
		virtual void setHoverSelection(bool b) {mHoverSelection = b;}
		virtual void setItemsShown(int numberOfElementsDisplayed);
		virtual void layoutSetup() {layoutSetupListbox();}
};

#endif // CSListbox_h
