#ifndef CSMenu_h
#define CSMenu_h

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>

#include "CSPicture.h"
#include "CSMessage.h"
#include "CSButton.h"
#include "CSGrafikElement.h"
#include "CSDesktop.h"
#include "CSLog.h"

#include "CSIcon.h"

class CSMenu;
class CSMenuItem;
class CSWindow;
class CSMenuBar;
typedef std::vector<CSMenu *> CSMenus;

class CSMenu : public CSButton
{
	private:
		std::string mTitle;
		bool mMenuIsOpen;

	protected:
		CSPanel *mMenuPanel;
		CSMenuBar *mMenuBar;
		void layoutSetupMenu();
		void initMenu();

	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}

		CSMenu(const std::string &menuTitle);
		virtual ~CSMenu();
		std::string getTitle() {return mTitle;}

		void reactOnMessageMenu(CSMessage *message);
		virtual void reactOnMessage(CSMessage *message);

		virtual void layoutSetup() {layoutSetupMenu();}
		virtual void addMenuItem(CSMenuItem *item);
		virtual void removeMenuItem(CSMenuItem *item);
		virtual void openMenu();
		virtual void closeMenu();
		virtual CSMenuBar *getMenuBar();
		void setMenuBar(CSMenuBar *bar);
		virtual int getButtonState();
};

#endif // CSMenu_h
