#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "CSMenuBar.h"
#include "CSLAF.h"
#include "CSDesktop.h"
#include "CSMenu.h"
#include "CSMessage.h"
#include "CSFont.h"

const char *CSMenuBar::CLASS = "CSMenuBar";

CSMenuBar::CSMenuBar(void) : CSBar(TYPE_HORIZONTAL)
{
	static char *functionName="CSMenuBar";
	LOG_ENTER 
	initMenuBar();
	LOG_EXIT
}

CSMenuBar::~CSMenuBar()
{
	static char *functionName="~CSMenuBar";
}

void CSMenuBar::initMenuBar()
{
	static char *functionName="initMenuBar";
	LOG_ENTER 
	mMenuState = BUTTON_DEFAULT;
	mActiveMenu = 0;
	mLastActiveMenu = 0;
	LOG_EXIT
}

void CSMenuBar::resetMenu() 
{
	closeLastMenu();
	if (mActiveMenu != 0)
	{
		mActiveMenu->closeMenu();
	}
	mLastActiveMenu = 0;
	mActiveMenu = 0;
	mMenuState = BUTTON_DEFAULT;
}

void CSMenuBar::setActiveMenu(CSMenu *menu) 
{
	if (menu == 0)
	{
		return;
	}
	if (mActiveMenu != menu)
	{
		mLastActiveMenu = mActiveMenu;
		mActiveMenu = menu;
	}
}
int CSMenuBar::getMenuState(CSMenu *menu) 
{
//	if (menu == mActiveMenu)
	{
		return mMenuState;
	}
	return BUTTON_DEFAULT; // only if enabled!
}

void CSMenuBar::closeLastMenu()
{
	if (mLastActiveMenu != 0)
	{
		mLastActiveMenu->closeMenu();
	}
}

void CSMenuBar::layoutSetupMenuBar()
{
	static char *functionName="layoutSetupMenuBar";
	LOG_ENTER 
	layoutSetupBar();
	LOG_EXIT
}
