#ifndef CSMenuBar_h
#define CSMenuBar_h

// USES SDL_Surface

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>

#include "CSPicture.h"
#include "CSMessage.h"
#include "CSButton.h"
#include "CSGrafikElement.h"
#include "CSDesktop.h"
#include "CSBar.h"
#include "CSLog.h"

#include "CSIcon.h"

class CSMenu;
class CSMenuBar;
typedef std::vector<CSMenuBar *> CSMenuBars;

class CSMenuBar : public CSBar
{
	private:
		CSMenu *mActiveMenu;
		CSMenu *mLastActiveMenu;

	protected:
		int mMenuState;
		void layoutSetupMenuBar();

	public:
		CSMenuBar(void);
		virtual ~CSMenuBar();
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}

		void initMenuBar();
//		void addMenu(CSMenu *menu); // should be prefered over addElement!
//		void addMenu(CSMenu *menu, int place); // should be prefered over addElement!
//		void removeMenu(CSMenu *menu);

		virtual void layoutSetup(){layoutSetupMenuBar();}
		virtual void setMenuState(int state) {mMenuState = state;}
		virtual void setActiveMenu(CSMenu *menu);
		virtual CSMenu *getActiveMenu(){return mActiveMenu;}
		virtual int getMenuState(CSMenu *menu);
		virtual void closeLastMenu();
		virtual void resetMenu();
		CSMenu *getLastActiveMenu() {return mLastActiveMenu;}
};

#endif // CSMenuBar_h
