#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "CSMenuItem.h"
#include "CSFont.h"
#include "CSPanel.h"

const char *CSMenuItem::CLASS = "CSMenuItem";

CSMenuItem::CSMenuItem(const std::string &itemName) : CSMenu(itemName)
{
	static char *functionName="CSMenuItem";
	LOG_ENTER 
	mMenuPanel->setGUIType("CSMenuItem");
	MESSAGE_MENUITEM_ACTIVATED.setSubtype(MENUITEM_ACTIVATED_MESSAGE);
	setFocusable(false);
	LOG_EXIT
}

void CSMenuItem::reactOnMessage(CSMessage *message)
{
	reactOnMessageMenuItem(message);
}

void CSMenuItem::reactOnMessageMenuItem(CSMessage *message)
{
	static char *functionName="reactOnMessage";
	if (message->mIsHandled)
	{
		reactOnMessageMenu(message);
		return;
	}
	if (message->getType() == GUI_MESSAGE)
	{
		GuiMessage *gm = (GuiMessage *) message;
		if (isChild(gm->receiver))
		//else // receiver == this
		{
			switch (message->getSubtype())
			{
				case MOUSE_MOTION_LOST_MESSAGE:
				{
					mBorderState = mBorderState & (~BUTTON_VISIBLE);
					gm->mIsHandled = true;
					break;
				}
				case MOUSE_MOTION_MESSAGE:
				{
					mBorderState = mBorderState | BUTTON_VISIBLE;
					mBorderState = mBorderState | BUTTON_HOVERING;
					gm->mIsHandled = true;
					break;
				}
				case MOUSE_BUTTON_PRESSED_MESSAGE:
				{
					mBorderState = mBorderState | BUTTON_PRESSED;
					gm->mIsHandled = true;
					break;
				}

				case MOUSE_BUTTON_RELEASED_MESSAGE:
				{
					mBorderState = BUTTON_DEFAULT;
					if (isChild(gm->downReceiver))
					{
						CSDesktop *desktop = getDesktop();
						if (desktop == 0)
						{
							break;
						}
						desktop->setFocusedComponent(0);
						MESSAGE_MENUITEM_ACTIVATED.actionId = mActionId;
						MESSAGE_MENUITEM_ACTIVATED.mIsHandled = false;
						sendMessage(MESSAGE_MENUITEM_ACTIVATED);
					}
					gm->mIsHandled = true;
					break;
				}
			}
		}
		else
		//if (gm->receiver != this)
		{
			if (message->getSubtype() == MOUSE_BUTTON_RELEASED_MESSAGE)
			{
				mBorderState = BUTTON_DEFAULT;
			}
		}
	}
}

void CSMenuItem::layoutSetupMenuItem()
{
	static char *functionName="layoutSetupMenuItem";
	LOG_ENTER 
	layoutSetupMenu();
	LOG_EXIT
}


