#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "CSMessageBox.h"
#include "CSIcon.h"
#include "CSLAF.h"
#include "CSLabel.h"
#include "CSFont.h"

const char *CSMessageBox::CLASS = "CSMessageBox";

CSMessageBox::CSMessageBox(std::string message, std::string title, int kind) 
: CSWindow(100,300)
{
	static char *functionName="CSMessageBox";
	LOG_ENTER 
	mKind = kind;
	mTextarea = 0;
	mIcon = 0;
	mMessage = message;

	setGUIType(CSWindow::CLASS);
	setModal(true);
	setTitle(title);
	setSizeable(true);
	rebuildElement();
	layoutSetup();
	LOG_EXIT
}

CSMessageBox::~CSMessageBox()
{
	static char *functionName="~CSMessageBox";
	LOG_ENTER 
	LOG_EXIT
}

void CSMessageBox::rebuildElement()
{
	CSLAF *laf = CSLAF::getCurrentLAF();

	if (mTextarea)
	{
		removeElement(mTextarea);
		delete (mTextarea);
		mTextarea = 0;
	}
	if (mIcon)
	{
		removeElement(mIcon);
		delete (mIcon);
		mIcon = 0;
	}

	rebuildElementWindow();
	
	mTextarea = new CSTextarea(100, 300);
	if (mKind == QUESTION_ICON)
	{
		mIcon = laf->getIcon(LAF_ICON_TYPE_QUESTION);
	}
	if (mKind == WARN_ICON)
	{
		mIcon = laf->getIcon(LAF_ICON_TYPE_WARN);
	}
	if (mKind == ERROR_ICON)
	{
		mIcon = laf->getIcon(LAF_ICON_TYPE_ERROR);
	}
	if (mKind == INFO_ICON)
	{
		mIcon = laf->getIcon(LAF_ICON_TYPE_INFO);
	}
	mTextarea->setMultiLineText(mMessage);
	mTextarea->setEditable(false); 
	addElement(mIcon, 20, (mHeight-20)/2-mIcon->getHeight()/2);
	addElement(mTextarea, 20 + mIcon->getX()+mIcon->getWidth(), 20);
}

void CSMessageBox::layoutSetupMessageBox()
{
	static char *functionName="layoutSetupMessageBox";
	LOG_ENTER 

	mHeight = 20+20 + mIcon->getHeight() + mTextarea->getHeight();
	mWidth = mIcon->getWidth()+3*20 + mTextarea->getWidth();
	mMinHeight = mHeight;
	mMinWidth = mWidth;

	mHeight += getBorder()->getTotalHeight() + getInset().getTotalHeight();
	mWidth += getBorder()->getTotalWidth() + getInset().getTotalWidth();

	layoutSetupWindow();
	LOG_EXIT
}
