#ifndef CSMessageBox_h
#define CSMessageBox_h

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>

#include "CSPicture.h"
#include "CSGrafikElement.h"
#include "CSDesktop.h"
#include "CSWindow.h"
#include "CSLog.h"
#include "CSTextarea.h"
#include "CSIcon.h"

class CSMessageBox;
typedef std::vector<CSMessageBox *> CSMessageBoxs;

const int WARN_ICON = 0;
const int ERROR_ICON = 1;
const int INFO_ICON = 2;
const int QUESTION_ICON = 3;

class CSMessageBox : public CSWindow
{
	private:
		CSIcons *mAttentionIcon;
		std::string mMessage;
		int mKind;
		CSTextarea *mTextarea;
		CSIcon *mIcon;

	protected:
		GuiMessage MESSAGE_WINDOW_CLOSE;
		void layoutSetupMessageBox();
		virtual void rebuildElement();

	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}

		CSMessageBox(std::string message, std::string title, int kind);
		virtual ~CSMessageBox();
		virtual void layoutSetup() {layoutSetupMessageBox();}
};

#endif // CSMessageBox_h
