#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "CSMouseCursor.h"
#include "CSPicture.h"

const char *CSMouseCursor::CLASS = "CSMouseCursor";

//----------------------------------------------------------------------
// FUNCTION: CSMouseCursor::CSMouseCursor
//----------------------------------------------------------------------

CSMouseCursor::CSMouseCursor(std::string pictureName)
{
	static char *functionName="CSMouseCursor";
	LOG_ENTER 
	mPicture = CSPictureLoader::INSTANCE.load(pictureName);
	mVisible = 1;
	mX = 0;
	mY = 0;
	LOG_EXIT
}

//----------------------------------------------------------------------
// FUNCTION: CSMouseCursor::~CSMouseCursor
//----------------------------------------------------------------------

CSMouseCursor::~CSMouseCursor()
{
	static char *functionName="~CSMouseCursor";
	LOG_ENTER 
	mPicture = 0;
	LOG_EXIT
}

//----------------------------------------------------------------------
// FUNCTION: CSMouseCursor::paint
//----------------------------------------------------------------------

void CSMouseCursor::paint(SDL_Surface *destination, SDL_Rect *parentViewport)
{
	static char *functionName="paint";
	if (mVisible) 
	{
		mPicture->display(parentViewport->x + mX, parentViewport->y + mY);
	}
}

//----------------------------------------------------------------------
// FUNCTION: CSMouseCursor::setPosition
//----------------------------------------------------------------------

void CSMouseCursor::setPosition(int x, int y)
{
	static char *functionName="setPosition";
	mX = x;
	mY = y;
}

//----------------------------------------------------------------------
// FUNCTION: CSMouseCursor::Hide
//----------------------------------------------------------------------

void CSMouseCursor::hide()
{
	static char *functionName="hide";
	mVisible = 0;
}

//----------------------------------------------------------------------
// FUNCTION: CSMouseCursor::Show
//----------------------------------------------------------------------

void CSMouseCursor::show()
{
	static char *functionName="show";
	mVisible = 1;
}
