#ifndef CSScrollbar_h
#define CSScrollbar_h

// USES SDL_Surface

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>

#include "CSGrafikElement.h"
#include "CSButton.h"
#include "CSIcon.h"
#include "CSMessage.h"
#include "CSLog.h"

class CSScrollbar;
class CSPanel;
typedef std::vector<CSScrollbar *> CSScrollbars;

class CSScrollbar : public CSGrafikElement
{
	private:
		CSButton *mLess;
		CSButton *mMore;
		CSDragButton *mHandle;
		int mKind;

		int mStart;
		int mEnd;
		int mDisplayStart;
		int mDisplayEnd;
		int mDisplayLength;
		int mDragPosition;
		void positionChanged();
		GuiMessage MESSAGE_SCROLLBAR_CHANGED;

	protected:
//		virtual void setParent(CSGrafikElement *parent);
		virtual void layoutSetupScrollbar();
		virtual void rebuildElement();
	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		CSScrollbar(int kind); // Button frees Icon!
		~CSScrollbar() {}
		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);

		void setStart(int start) {mStart=start;}
		void setEnd(int end) {mEnd=end;}
		void setDisplayStart(int start) {mDisplayStart=start;}
		void setDisplayEnd(int end) {mDisplayEnd=end;}
		void setDisplayLength(int length) {mDisplayLength=length;} // Anzahl der anzuzeigenden elemente
		void reactOnMessageScrollbar(CSMessage *message);
		virtual void reactOnMessage(CSMessage *message);
		virtual void layoutSetup() {layoutSetupScrollbar();}
};
#endif // CSScrollbar_h
