#ifndef CSTabbedPane_h
#define CSTabbedPane_h

// USES SDL_Surface

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>

#include "CSGrafikElement.h"
#include "CSPanel.h"
#include "CSLog.h"

class CSTabbedPane;
typedef std::vector<CSTabbedPane *> CSTabbedPanes;

class NamedPanel;
typedef std::vector<NamedPanel *> NamedPanels;

class NamedPanel
{
	public:
		CSPanel *mPanel;
		std::string mName;
		
		NamedPanel()
		{
			mPanel = 0;
			mName = "";
		}

		NamedPanel(CSPanel *panel, std::string name)
		{
			mPanel = panel;
			mName = name;
		}

};


class CSTabbedPane : public CSGrafikElement
{
	private:
		NamedPanels mNamedPanels;
		int	mActivePanelNumber;
		std::string mActivePanelName;
		CSPanel *mButtonPanel;

	protected:
		virtual void rebuildElement();
		void initTabbedPane();
		void layoutSetupTabbedPane();

	public:
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}

		CSTabbedPane() : CSGrafikElement(0,0) 
		{
			initTabbedPane();
		}
		CSTabbedPane(int w, int h);
		virtual ~CSTabbedPane() {}

		virtual void reactOnMessage(CSMessage *message);
		virtual void reactOnMessageTabbedPane(CSMessage *message);
		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);

		virtual bool isFocusable() {return false;}
		virtual void layoutSetupLayout() {layoutSetupTabbedPane();}

		virtual void setActivePane(int n);
		virtual int getActivePane();
		virtual void setActivePaneName(std::string name);
		virtual std::string getActivePaneName();

		virtual void addElement(CSGrafikElement *element, int position)
		{
			// do nothing!
		}

		virtual void addElement(CSGrafikElement *element, int x, int y)
		{
			// do nothing!
		}
		
		virtual void addElement(CSGrafikElement *element)
		{
			// do nothing!
		}

		virtual void addElement(CSGrafikElement *element, std::string name);
};

#endif // CSTabbedPane_h
