#ifndef CSTextfield_h
#define CSTextfield_h

// USES SDL_Surface

#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include <vector>
#include <string>

#include "CSGrafikElement.h"
#include "CSLog.h"

class CSTextfield;
typedef std::vector<CSTextfield *> CSTextfields;

class CSTextfield : public CSGrafikElement
{
	private:
		GuiMessage MESSAGE_TEXT_CHANGED;
		std::string mString;
		std::string mWorkingString;
		void init(const std::string &text);
		float mTickTimeNext;
		float mCursorRate;
		bool mCursorShown;

	protected:
		virtual void layoutSetupTextfield();
	public:
		CSTextfield();
		CSTextfield(int width);
		CSTextfield(const std::string &string);
		virtual ~CSTextfield() {}
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		
		void reactOnMessageTextField(CSMessage *message);
		virtual void reactOnMessage(CSMessage *message);

		virtual void paint(SDL_Surface *destination, SDL_Rect *parentViewport);
		virtual void putString(SDL_Surface *destination, SDL_Rect *parentViewport, int x1, int y1, const std::string &string);
		virtual std::string getText() {return mString;}
		virtual void setText(std::string s) {mString = s;}
		virtual void layoutSetup() {layoutSetupTextfield();}
};

#endif // CSTextfield_h
