/*High Score
Anzahl Lebel + Test
Gamestart
Score Display

Achievements
(count dots)
- wie viele geister mit 1600


- Freischalten eines Bonus bei Geist mit 1600 gefressen
- freischalten level ohne pillen
- freischalten bei 4 pillen in a row
- x level ohne death
- x level (punkte ) ohne geist...

- tunnel level, mit nur einem weg, der bis zu ende fhrt (wenig dots) - grosser bonus


No Log Exit:

  void CSDesktop::setFocusedComponent(CSGrafikElement *element)



void CSDesktop::onMouseUp(int x, int y)


void CSDesktop::onMouseDown(int x, int y)

CSMenuBar *CSMenu::getMenuBar() 
void CSHTMLPanel::layoutSetupHTMLPanel()

void CSFont::resetSurface()
void CSGame::loadGameData(const std::string &filename)
void CSWorld::addSprite(CSSprite *sprite)

*/


#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "PacmanGame.h"
#include "GhostNavigators.h"
#include "PacmanNavigator.h"

#include "CSWindow.h"
#include "CSLabel.h"
#include "CSButton.h"
#include "CSCheckBox.h"
#include "CSTextfield.h"
#include "CSScrollbar.h"
#include "CSTextarea.h"
#include "CSListbox.h"
#include "CSCombobox.h"
#include "CSHTMLPanel.h"

#include "CSIcon.h"
#include "CSMessageBox.h"
#include "CSLAF.h"

// definitions like in tile/typed.dtd
const int PACMAN_TILE_DOT = 0;
const int PACMAN_TILE_PILL = 1;
const int PACMAN_TILE_GHOST_HOUSE = 2;
const int PACMAN_TILE_BONUS = 3;

const int PACMAN_TYPE = 0;
const int GHOST_TYPE = 1;

const int NORMAL_USER_STATE = 0;
const int BLUE_USER_STATE = 1;

const int PACMAN_CONFIGURATION_ACTION_ID = 10000;

const char *PacmanGame::CLASS = "PacmanGame";

PacmanGame::PacmanGame(std::string gameFileName) 
: CSGame(gameFileName)
{
	static char *functionName="PacmanGame";
	LOG_ENTER 
//	CSLAF::setCurrentLAF(mPacmanLAF);
				CSLAF::setCurrentLAF(mWindowLAF);
	mLevelCurrentGhostScore = 0;
	mLevelDotCount = 0;

	mLevelCurrentPillCount = 0;
	mLevelCurrentPillCountInARow = 0;
	
	mLevelPillCount = 0;
	mLevelGhostAfraidTime = 0;
	mLevelGhostBlueSpeed = 0;
	mLevelGhostEyeSpeed = 0;
	mLevelCurrentDotCount = 0;
	mLevelBonusValue = 0;
	mLevelBonusX = 0;
	mLevelBonusY = 0;
	mLevelBonusFilename = "";
	mBonusSaveTile = 0;
	mBonusTile = 0;
	mScaleFactor = 1.5;
	mScaleCenterSpriteId = "";

	enableDesktop(true);
//	enableDesktop(false);


	mSkinUp = CSPictureLoader::INSTANCE.load("picture\\skin_up.xml");
	mSkinDown = CSPictureLoader::INSTANCE.load("picture\\skin_down.xml");
	mSkinLeft = CSPictureLoader::INSTANCE.load("picture\\skin_left.xml");
	mSkinRight = CSPictureLoader::INSTANCE.load("picture\\skin_right.xml");
	mSkinHorizontalLeft = CSPictureLoader::INSTANCE.load("picture\\skin_horizontal_left.xml");
	mSkinHorizontalRight = CSPictureLoader::INSTANCE.load("picture\\skin_horizontal_right.xml");
	mSkinVerticalMid = CSPictureLoader::INSTANCE.load("picture\\skin_vertical_mid.xml");

	mPacmanMenu = new CSMenu((std::string)"Pacman");
	mMenuItemConfiguration = new CSMenuItem("Configuration");
	mMenuItemConfiguration->setActionId(PACMAN_CONFIGURATION_ACTION_ID);
	mMenuItemConfiguration->addMessageListener(this, GUI_MESSAGE);
	mPacmanMenu->addMenuItem(mMenuItemConfiguration);
	mMenuBar->addElement(mPacmanMenu);

	mPacmanConfigWindow = new PacmanConfigWindow(this);
	mDesktop->addElement(mPacmanConfigWindow, 100, 100);


/*
  	CSWindow *window;
	window = new CSWindow(CSPictureLoader::INSTANCE.load("picture\\window.xml"));
	mDesktop->addElement(window, 30, 30);
*/
CSWindow *window = new CSWindow(200,400);
mDesktop->addElement(window, 10, 10);
CSLabel *label = new CSLabel("Hello World!");
window->addElement(label, 5, 20);

CSButton *button = new CSButton(CSTextIcon::buildIcon("Cancel"));
button->setActionId(55);
button->addMessageListener(this, GUI_MESSAGE);
window->addElement(button, 30, 70);

CSCheckBox *checkBox = new CSCheckBox();
checkBox->setActionId(56);
checkBox->addMessageListener(this, GUI_MESSAGE);
window->addElement(checkBox, 45, 30);

CSTextfield *textfield = new CSTextfield();
textfield->setActionId(56);
textfield->addMessageListener(this, GUI_MESSAGE);
textfield->setWidth(100);
window->addElement(textfield, 45, 45);

CSPictureIcon* icon = CSPictureIcon::buildIcon("picture\\pacIconEnabled.xml");
icon->setState(ICON_STATE_ENABLED);
window->addLeftIcon(icon);

CSTextIcon *ticon = CSTextIcon::buildIcon("Text");
window->addLeftIcon(ticon);
window->addElement(icon, 45, 200);

CSScrollbar *scrollbar = new CSScrollbar(TYPE_VERTICAL);
window->addElement(scrollbar, 0, 0);
scrollbar->addMessageListener(this, GUI_MESSAGE);

CSTextarea *textarea = new CSTextarea(80,200);
window->addElement(textarea, 10, 110);

CSCombobox *combobox =  new CSCombobox(200);
window->addElement(combobox, 300, 110);
CSStringlist list;
list.add("First");
list.add("Second");
list.add("Third");
list.add("fourth");
list.add("fifth");
list.add("sixth");
list.add("seventh");
list.add("eighth");
list.add("nineth");
combobox->setItems(list);

CSListbox *listbox =  new CSListbox(5,200);
window->addElement(listbox, 10, 200);
CSStringlist list2;
list2.add("First");
list2.add("Second");
list2.add("Third");
list2.add("fourth");
list2.add("fifth");
list2.add("sixth");
list2.add("seventh");
list2.add("eighth");
list2.add("nineth");
listbox->setItems(list2);




	CSHTMLPanel *html = new CSHTMLPanel(-1, -1, "index.html");
	CSWindow * window2 = new CSWindow(200,600);

	
	window2->setLayoutManager(new CSLayoutManagerBorder());
	window2->setVisible(true);
	window2->addElement(html, POSITION_CENTER);
	CSLayoutData layout = window2->getLayoutDataMainElement();
	layout.setOversize(false);
	window2->setLayoutDataMainElement(layout);
	
	
	mDesktop->addElement(window2, 30, 30);


window->setVisible(true);



	mPacman = 0;
	mNavigator = 0;
	LOG_EXIT
}

PacmanGame::~PacmanGame()
{
	static char *functionName="~PacmanGame";
	LOG_ENTER 
	LOG_EXIT
}

void PacmanGame::loadLevelDataSpecific(CSXMLHelper &xmlSupport)
{
	
	mLevelDotCount = xmlSupport.getInt("DOT_COUNT");
	mLevelPillCount = xmlSupport.getInt("PILL_COUNT");
	mLevelGhostAfraidTime = xmlSupport.getInt("GHOST_AFRAID_TIME");
	mLevelGhostBlueSpeed = xmlSupport.getInt("GHOST_BLUE_SPEED");
	mLevelGhostEyeSpeed = xmlSupport.getInt("GHOST_EYE_SPEED");

	// load Boni!
	mLevelBonusFilename = xmlSupport.getString("BONUS/NAME");
	mLevelBonusValue = xmlSupport.getInt("BONUS/VALUE");
	mLevelBonusX = xmlSupport.getInt("BONUS/POSITION/X");
	mLevelBonusY = xmlSupport.getInt("BONUS/POSITION/Y");
	mBonusTile = buildBonusTile(mLevelBonusFilename);
	
	/*
	Vector specialBonusNames = new Vector();
	int count = xmlSupport.getInt("count(SPECIAL_BONUS)");
	for (i=0; i<count; i++)
	{
		char *bonusName;
		// i+1, predicates in xpath start with 1
		std::string name = xmlSupport.getString((std::string)"SPECIAL_BONUS["+itoa(i+1,tmp,10)+"]/NAME");
		bonusName =  strdup(name.c_str());
		bonusName->worlds.push_back(bonusName);
	}
	*/
}

void PacmanGame::freeLevelSpecific()
{
	static char *functionName="freeLevelSpecific";
	LOG_ENTER 
	if (getWorld() != 0)
	{
		disableOutOfBoundsCheck(mPacman, this);
		disableTileCollisionCheck(mPacman, getDotLayer(), this);
	}
	removeMessageListener(this, GAME_MESSAGE);

	if (mPacman)
	{
		mNavigator->deinit();
	}

	CSSprites::iterator iter = mSprites.begin();
	while (iter != mSprites.end())
	{
		CSSprite *sprite = *iter;
		if (sprite->getSpriteType() == GHOST_TYPE)
		{
			GhostNavigator *navigator = (GhostNavigator *)sprite->getNavigator();
			disableOutOfBoundsCheck(sprite, this);
			disableSpriteCollisionCheck(mPacman, sprite, this);
			mNavigator->removeEnemy(sprite);
			delete(navigator);
			sprite->clearNavigator();
		}

		iter++;
	}
	if (mPacman)
	{
		delete(mNavigator);
		mPacman->clearNavigator();
	}
	// Sprites (even Pacman) not to be deleted -> is done by Game

	// make sure the tile is not part of the tileset!
	if (mBonusSaveTile !=0 )
	{
		removeBonus();
	}

	delete (mBonusTile);
	mBonusTile = 0;
	// remove events, don't bother whether they are set or not
	removeTimedEvent(REMOVE_BONUS_EVENT, 0);
	removeTimedEvent(DISPLAY_BONUS_EVENT, 0);
	mPacmanConfigWindow->setVisible(false);

	mPacman = 0;
	mNavigator = 0;
	LOG_EXIT
}

void PacmanGame::initLevelSpecific(CSLevelData *data)
{
	static char *functionName="initLevelSpecific";
	LOG_ENTER 
	mPacman = getMainSprite();
	
	mNavigator = new PacmanNavigator();
	mNavigator->setGame(this);
	mNavigator->setLayer(getMazeLayer());
	mPacman->setNavigator(mNavigator);

	CSSprites::iterator iter = mSprites.begin();
	while (iter != mSprites.end())
	{
		CSSprite *sprite = *iter;
		if (sprite->getSpriteType() == GHOST_TYPE)
		{
			GhostNavigator *navigator = new PrudentNavigator();
			navigator->setLayer(getMazeLayer());
			navigator->setGame(this);
			sprite->setNavigator(navigator);
			mNavigator->addEnemy(sprite);
			enableSpriteCollisionCheckPixel(mPacman, sprite, this, 150);
			enableOutOfBoundsCheck(sprite, this, -10);
		}
		iter++;
	}
	mNavigator->init();
	resetSpritesSpecific();

	addMessageListener(this, GAME_MESSAGE);
	enableTileCollisionCheck(mPacman, getDotLayer(), this);
	enableOutOfBoundsCheck(mPacman, this, 0);

// doesnt work don know yet why
// parallax in scaled map not supported
//setScaleDisplayLayer(true, getMazeLayer()-1);
	setScaleDisplayLayer(true, getMazeLayer());
	setScaleDisplayLayer(true, getDotLayer());

	setDisplayScaled(true);
	mLevelCurrentGhostScore = 200;
	mLevelCurrentDotCount = 0;
	mLevelCurrentPillCount = 0;
	mLevelCurrentPillCountInARow = 0;
	addTimedEvent(BONUS_WAIT_TIME, DISPLAY_BONUS_EVENT, 0);
	mBonusSaveTile = 0;

	if (mScaleCenterSpriteId.length() == 0)
	{
		mScaleCenterSpriteId = mPacman->getId();
	}

	mScaleCenterSprite = 0;
	if (strcmp(mScaleCenterSpriteId.c_str(), mMainSprite->getId().c_str()) == 0)
	{
		mScaleCenterSprite = mMainSprite;
	}
	else
	{
		CSSprites::iterator iter = mSprites.begin();
		while (iter != mSprites.end())
		{
			CSSprite *sprite = *iter;
			if (sprite->getSpriteType() == GHOST_TYPE)
			{
				if (strcmp(mScaleCenterSpriteId.c_str(), sprite->getId().c_str()) == 0)
				{
					mScaleCenterSprite = sprite;
				}
			}
			iter++;
		}
	}
	if (mScaleCenterSprite == 0)
	{
		mScaleCenterSprite = mMainSprite;
	}
	mScaleCenterSpriteId = mScaleCenterSprite->getId();
	mCurrentWorld->displayScaled(mScaleCenterSprite);


	LOG_EXIT
}

void PacmanGame::displayGameData()
{
	mSkinUp->display(0,0);
	mSkinLeft->display(0,0);
	mSkinRight->display(635,0);
	mSkinDown->display(0,475);
	mSkinHorizontalLeft->display(0,406);
	mSkinHorizontalRight->display(506,104);
	mSkinVerticalMid->display(506,0);
}

void PacmanGame::startRun()
{
	static char *functionName="startRun";
}

SDL_Rect PacmanGame::getDisplayArea()
{
	static char *functionName="getDisplayArea";
	SDL_Rect area;
	area.x = 0;
	area.y = 0;
	area.w = 500;
	area.h = 400;
	return area;
}

SDL_Rect PacmanGame::getScaledDisplayArea()
{
	static char *functionName="getScaledDisplayArea";
	SDL_Rect area;
	area.x = 511;
	area.y = 5;
	area.w = 124;
	area.h = 99;
	return area;
}

double PacmanGame::getScaleFactor()
{
	static char *functionName="getScaleFactor";
	return mScaleFactor;
}

void PacmanGame::reactOnMessage(CSMessage *message)
{
	reactOnMessageGame(message);
	reactOnMessagePacmanGame(message);
}

void PacmanGame::reactOnMessagePacmanGame(CSMessage *message)
{
	static char *functionName="reactOnMessageUndelivered";
	if (message->getType() == SPRITE_MESSAGE)
	{
		if (message->getSubtype() == SPRITE_ACTION_CHANGE_MESSAGE)
		{
			mPacman->setActive(false);
		}
	}
	else if (message->getType() == GAME_MESSAGE)
	{
		GameMessage *gm = (GameMessage *) message;

		if (gm->getSubtype() == RESURRECT_GHOST_MESSAGE)
		{
			MESSAGE_SPRITE_STATE_CHANGE.state = GH0ST_DEFAULT_STATE;
			gm->sprite->dispatchMessage(&MESSAGE_SPRITE_STATE_CHANGE);
			removeTimedEvent(GHOST_TURN_EYES, gm->sprite);

			int num = getLevelDataNum(gm->sprite);
			if (num != -1)
			{
				gm->sprite->adjustSpeed(mLevelData->sprites.at(num)->speed);
			}
		}
		// sprite hits dots
		else if (gm->getSubtype() == SPRITE_TILE_COLLISION_MESSAGE)
		{
			if (gm->layer == getDotLayer())
			{
				/*
				// definitions like in tile/typed.dtd
				const int PACMAN_TILE_DOT = 0;
				const int PACMAN_TILE_PILL = 1;
				const int PACMAN_TILE_GHOST_HOUSE = 2;
				const int PACMAN_TILE_BONUS = 3;
				*/				
				
#define BLANK 'x'

				if (gm->tile->getTileType() == PACMAN_TILE_DOT)
				{
					playSample("SAMPLE_DOT");
					getWorld()->setTile(gm->tile->getMapPositionX(), gm->tile->getMapPositionY(), gm->layer, BLANK);
					mLevelCurrentDotCount++;
					mLevelCurrentPillCountInARow = 0;
				}
				else if (gm->tile->getTileType() == PACMAN_TILE_PILL)
				{
					playSample("SAMPLE_PILL");
					makeGhostsBlue();
					getWorld()->setTile(gm->tile->getMapPositionX(), gm->tile->getMapPositionY(), gm->layer, BLANK);
					mLevelCurrentPillCount++;
					mLevelCurrentPillCountInARow++;
				}
				else if (gm->tile->getTileType() == PACMAN_TILE_BONUS)
				{
					playSample("SAMPLE_PILL");
					removeBonus();
					addTimedEvent(BONUS_WAIT_TIME, DISPLAY_BONUS_EVENT, 0);
				}

				if (mLevelCurrentDotCount + mLevelCurrentPillCount == mLevelDotCount)
				{
					setLevelFinished(true);
				}

			}
		}
		
		// sprite hits ghost
		else if (gm->getSubtype() == SPRITE_SPRITE_COLLISION_MESSAGE)
		{
			int state = gm->other->getCurrentStateId();
			
			if ((state & (GH0ST_BLUE_STATE)) == GH0ST_BLUE_STATE)
			{
				if (mLevelCurrentGhostScore == 200)
				{
					MESSAGE_SPRITE_STATE_CHANGE.state = GH0ST_SCORE_STATE_200;
				}
				if (mLevelCurrentGhostScore == 400)
				{
					MESSAGE_SPRITE_STATE_CHANGE.state = GH0ST_SCORE_STATE_400;
				}
				if (mLevelCurrentGhostScore == 800)
				{
					MESSAGE_SPRITE_STATE_CHANGE.state = GH0ST_SCORE_STATE_800;
				}
				if (mLevelCurrentGhostScore == 1600)
				{
					MESSAGE_SPRITE_STATE_CHANGE.state = GH0ST_SCORE_STATE_1600;
				}
				mLevelCurrentGhostScore *=2;
				gm->other->setUserState(NORMAL_USER_STATE);
				gm->other->adjustSpeed(mLevelGhostEyeSpeed);
				gm->other->dispatchMessage(&MESSAGE_SPRITE_STATE_CHANGE);
				addTimedEvent(2000, GHOST_TURN_EYES,gm->other);
				playSample("SAMPLE_EATGHOST");
			}
			else if ((state & (GH0ST_SCORE_STATE | GH0ST_EYE_STATE)) == 0)
			{
				if (strcmp(mPacman->getCurrentActionId(), "PAC_DEATH_ACTION"))
				{
					mPacman->dispatchMessage(&MESSAGE_DEATH);
					playSample("SAMPLE_DEAD");
					removeBonus();

					clearTimedEvents();					
					disableSpriteMovement();
					enableCheck(false);
					addTimedEvent(3300, RESET_LEVEL ,0);
					mPacman->addMessageListener(this, SPRITE_MESSAGE);
				}
			}
		}
		
		// sprites reappear on the other side of the screen!
		else if (gm->getSubtype() == SPRITE_OUT_OF_BOUNDS_MESSAGE)
		{
			int type = gm->getSubsubtype();
			CSSprite *sprite = gm->sprite;
			
			if (type == X_LOWER)
			{
				if (sprite->getCurrentActionType() != WEST_ACTION)
				{
					return;
				}
				int x = getWorld()->getWidth() - sprite->getMaxWidth();
				sprite->setPosition(x, sprite->getYPos(), sprite->getWorldPos());
			}
			if (type == Y_LOWER)
			{
				if (sprite->getCurrentActionType() != NORTH_ACTION)
				{
					return;
				}
				int y = getWorld()->getHeight() - sprite->getMaxHeight();
				sprite->setPosition(sprite->getXPos(), y, sprite->getWorldPos());
			}
			if (type == X_HIGHER)
			{
				if (sprite->getCurrentActionType() != EAST_ACTION)
				{
					return;
				}
				sprite->setPosition(0, sprite->getYPos(), sprite->getWorldPos());
			}
			if (type == Y_HIGHER)
			{
				if (sprite->getCurrentActionType() != SOUTH_ACTION)
				{
					return;
				}
				sprite->setPosition(sprite->getXPos(), 0, sprite->getWorldPos());
			}
		}

	}
	if (message->getType() == GUI_MESSAGE)
	{
		GuiMessage *gm = (GuiMessage *) message;
//		if (gm->getSubtype() == BUTTON_PRESSED_MESSAGE)
//		{
//			if (gm->actionId == 55)
//			{
//				CSLAF::setCurrentLAF(mWindowLAF);
/*
	CSWindow *window = new CSWindow(300, 300);
	CSLabel *label = new CSLabel("Hello World!");
	window->addElement(label, 5, 20);
	mDesktop->addElement(window, 100, 100);
	window->setModal(true);
	window->setVisible(true);
//	delete(label);
//	delete(window);
*/
//	CSMessageBox *message = new CSMessageBox("This is a warning message!", "Warning Message", WARN_ICON);
//	mDesktop->addElement(message, 100, 100);
//	message = new CSMessageBox("This is an error message!", "Error Message", ERROR_ICON);
//	mDesktop->addElement(message, 100, 100);
			
//			}
//		}
//		if (gm->getSubtype() == CHECKBOX_CHANGED_MESSAGE)
//		{
//			if (gm->actionId == 56)
//			{
//				if (gm->newCheckBoxState)
//				{
//					CSLAF::setCurrentLAF(mPacmanLAF);
//				}
//			}
//		}
//		
//		if (gm->getSubtype() == SCROLLBAR_POSITION_CHANGED_MESSAGE)
//		{
//			nextLevel();
//		}

		if (gm->getSubtype() == MENUITEM_ACTIVATED_MESSAGE)
		{
			if (gm->actionId == PACMAN_CONFIGURATION_ACTION_ID)
			{
				mPacmanConfigWindow->setVisible(true);

			}
		}
	}
}

int PacmanGame::getDotLayer()
{
	static char *functionName="getDotLayer";
	int i = mCurrentWorld->getLayerCount()-1;
	return i;
}

int PacmanGame::getMazeLayer()
{
	static char *functionName="getMazeLayer";
	int i = mCurrentWorld->getLayerCount()-2;
	return i;
}

void PacmanGame::adjustPositionToTile(CSSprite *sprite)
{
	static char *functionName="adjustPositionToTile";
	int x = sprite->getXPos();
	int y = sprite->getYPos();
	x = x*50-(50-30);
	y = y*40-(40-24);
	//const int X_OFFSET = 30;	// Pacman middle X
	//const int Y_OFFSET = 24;	// Pacman middle y
	sprite->setPosition(x,y,sprite->getWorldPos());
}

void PacmanGame::makeGhostsBlue()
{
	static char *functionName="makeGhostsBlue";
	LOG_ENTER 
	for (CSSprites::iterator iter = mSprites.begin(); iter!=mSprites.end();iter++)
	{
		CSSprite *sprite = *iter;
		if (sprite != mMainSprite)
		{
			if (sprite->getCurrentStateId() == GH0ST_DEFAULT_STATE)
			{
				sprite->setUserState(BLUE_USER_STATE);
			}
			int state = sprite->getCurrentStateId();
			if ((state & (GH0ST_BLUE_STATE | GH0ST_SCORE_STATE | GH0ST_EYE_STATE)) == 0)
			{				
				MESSAGE_SPRITE_STATE_CHANGE.state = GH0ST_BLUE_STATE;
				sprite->dispatchMessage(&MESSAGE_SPRITE_STATE_CHANGE);
			}
			sprite->adjustSpeed(mLevelGhostBlueSpeed);
		}
	}
	
	removeTimedEvent(GHOST_TURN_NORMAL);
	removeTimedEvent(GHOST_TURN_FLICKER);
	mLevelCurrentGhostScore = 200;
	addTimedEvent(mLevelGhostAfraidTime, GHOST_TURN_FLICKER,0);
	LOG_EXIT
}

void PacmanGame::makeGhostsNormal()
{
	static char *functionName="makeGhostsNormal";
	LOG_ENTER 
	for (CSSprites::iterator iter = mSprites.begin(); iter!=mSprites.end();iter++)
	{
		CSSprite *sprite = *iter;
		if (sprite != mMainSprite)
		{
			int tstate = sprite->getUserState();
			if (tstate == BLUE_USER_STATE)
			{
				sprite->setUserState(NORMAL_USER_STATE);
				MESSAGE_SPRITE_STATE_CHANGE.state = GH0ST_DEFAULT_STATE;
				sprite->dispatchMessage(&MESSAGE_SPRITE_STATE_CHANGE);
				int num = getLevelDataNum(sprite);
				if (num != -1)
				{
					sprite->adjustSpeed(mLevelData->sprites.at(num)->speed);
				}
			}
		}
	}
	LOG_EXIT
}

void PacmanGame::removeBonus()
{
	if (mBonusSaveTile != 0)
	{
		removeTimedEvent(REMOVE_BONUS_EVENT, 0);
		CSTileMap *tileMap = getWorld()->getLayer(getDotLayer());
		CSTileSet *tileSet = tileMap->getTileSet();
		tileSet->setTile(0, mBonusTile->getIDChar()); // this removes the bonus tile from the tileset
		getWorld()->setTile(mLevelBonusX, mLevelBonusX, getDotLayer(), mBonusSaveTile);
		mBonusSaveTile = 0;
	}
}

void PacmanGame::reInitLevel()
{
	// all timed events were removed, so init bonus timer...
	addTimedEvent(BONUS_WAIT_TIME, DISPLAY_BONUS_EVENT, 0);
	resetSprites();
}

void PacmanGame::reactOnTimedEvent(TimedEvent *event)
{
	static char *functionName="reactOnTimedEvent";
	switch (event->id)
	{
		case RESET_LEVEL:
		{
			while (isSamplePlaying());
			{
				SDL_Delay(50);
			}

					mPacman->removeMessageListener(this);
			mPacman->setActive(true);
			reInitLevel();
			break;
		}
		case GHOST_TURN_FLICKER:
		{
			addTimedEvent(100, GHOST_TURN_NORMAL,0, 10, true);
			break;
		}
		case GHOST_TURN_NORMAL:
		{
			int state = ((event->repeat%2) == 1) ? GH0ST_DEFAULT_STATE : GH0ST_BLUE_STATE;
			for (CSSprites::iterator iter = mSprites.begin(); iter!=mSprites.end();iter++)
			{
				CSSprite *sprite = *iter;
				if (sprite != mMainSprite)
				{
					int tstate = sprite->getUserState();
					if (tstate == BLUE_USER_STATE)
					{				
						MESSAGE_SPRITE_STATE_CHANGE.state = state;
						sprite->dispatchMessage(&MESSAGE_SPRITE_STATE_CHANGE);
					}
				}
			}
			if (event->repeat == 1)
			{
				makeGhostsNormal();
			}
			break;
		}
		
		case GHOST_TURN_EYES:
		{
			CSSprite *sprite = (CSSprite *) event->data;
			MESSAGE_SPRITE_STATE_CHANGE.state = GH0ST_EYE_STATE;
			sprite->dispatchMessage(&MESSAGE_SPRITE_STATE_CHANGE);
			break;
		}
		case DISPLAY_BONUS_EVENT:
		{
			mBonusSaveTile = getWorld()->getTile(mLevelBonusX, mLevelBonusX, getDotLayer());

			CSTileMap *tileMap = getWorld()->getLayer(getDotLayer());
			CSTileSet *tileSet = tileMap->getTileSet();
			tileSet->setTile(mBonusTile, mBonusTile->getIDChar());
			getWorld()->setTile(mLevelBonusX, mLevelBonusX, getDotLayer(), mBonusTile);
			
			// Display Bonus for 10 seconds
			addTimedEvent(BONUS_DISPLAY_TIME, REMOVE_BONUS_EVENT, 0);
			break;
		}
		case REMOVE_BONUS_EVENT:
		{
			removeBonus();
			addTimedEvent(BONUS_WAIT_TIME, DISPLAY_BONUS_EVENT, 0);
			break;
		}
	}
}

void PacmanGame::resetSpritesSpecific()
{
	static char *functionName="resetSpritesSpecific";
	LOG_ENTER 
	SpriteState sState = mPacman->getState();
	mNavigator->reset();
	mPacman->resetState(sState);
	mPacman->setState(sState);
	mPacman->resetNavigator();
	adjustPositionToTile(mPacman);
	mMainSprite->adjustSpeed(mLevelData->mainSprite.speed);

	CSSprites::iterator iter = mSprites.begin();
	while (iter != mSprites.end())
	{
		CSSprite *sprite = *iter;
		if (sprite->getSpriteType() == GHOST_TYPE)
		{
			sState = sprite->getState();
			sprite->resetState(sState);
			sprite->setState(sState);
			sprite->resetNavigator();
			adjustPositionToTile(sprite);
			int num = getLevelDataNum(sprite);
			if (num != -1)
			{
				sprite->adjustSpeed(mLevelData->sprites.at(num)->speed);
			}
		}
		iter++;
	}
	

	enableCheck(true);
	LOG_EXIT
}

CSTile * PacmanGame::buildBonusTile(std::string bonusName)
{
	static char *functionName="buildBonusTile";
	CSTile *tile = 0;
	LOG_ENTER 

	std::string tileName;
	CSXMLHelper xmlSupport(bonusName, "BONUS");
	try
	{
		if (xmlSupport.getError())
		{
			throw "error";
		}

		tileName = xmlSupport.getString("TILE");
		tile = CSTileLoader::INSTANCE.load(tileName);
	}
	catch(...)
	{
		LOG_EXIT
		SDLMain::shutdown((std::string)"XML error \"" + bonusName + "\": " + xmlSupport.getErrorMessage().c_str(), 1);
	}
	LOG_EXIT 
	return tile;
}






















#define NUMBER_OF_STARS 120

/*star struct*/
typedef struct 
{
  float xpos, ypos;
  short zpos, speed;
  Uint8 color;
} STAR;

static STAR stars[NUMBER_OF_STARS];

void init_star(STAR* star, int i)
{
  /* randomly init stars, generate them around the center of the screen */
  
  star->xpos =  -10.0 + (20.0 * (rand()/(RAND_MAX+1.0)));
  star->ypos =  -10.0 + (20.0 * (rand()/(RAND_MAX+1.0)));
  
  star->xpos *= 3072.0; /*change viewpoint */
  star->ypos *= 3072.0;

  star->zpos =  i;
  star->speed =  2 + (int)(2.0 * (rand()/(RAND_MAX+1.0)));
  star->speed =  1;

  star->color = i >> 2; /*the closer to the viewer the brighter*/
}

void init()
{
  int i;
  
  /* create and set palette */
/*
  colors[0].r = 0;
  colors[0].g = 0;
  colors[0].b = 0;

  for (i = 0; i < 255; ++i)
    {
      colors[255 - i].r = i;
      colors[255 - i].g = i;
      colors[255 - i].b = i;
    }
  
  SDL_SetPalette(screen, SDL_LOGPAL | SDL_PHYSPAL, colors, 0, 256); 
*/
  for (i = 0; i < NUMBER_OF_STARS; i++)
    {
      init_star(stars + i, i + 1);
    }

}


void PacmanGame::intro(void)
{
	static char *functionName="intro";
	LOG_ENTER 

	CSPicture *sphere = CSPictureLoader::INSTANCE.load("picture\\sphere.xml");
	CSPicture **sphereSizes = (CSPicture **) new void *[NUMBER_OF_STARS+1];

	int MAX_SIZE = 60;
	int MIN_SIZE = 1;
		
	double factor = 0.5;//0.2;
	for (int i=0;i<NUMBER_OF_STARS+1; i++)
	{
		sphereSizes[NUMBER_OF_STARS-i] = CSPicture::createScaledPicture(sphere, (float) (((float)1)/(float) ((NUMBER_OF_STARS -i)/10) ) );
		sphereSizes[NUMBER_OF_STARS-i]->setSolid(false);
	}
	
	mCurrentTime = SDL_GetTicks();
	mDiffTime = 0;
	mSecPerFrame = 0;
	initSpeed();

	Uint16 centerx, centery;
	int tempx, tempy;  
	centerx = (SDLMain::getScreenWidth()) >> 1;
	centery = (SDLMain::getScreenHeight()) >> 1;
	while (!mQuit)
	{
		static int count = 0;
		static int rate = 0;
		mCurrentTime = SDL_GetTicks();
		handleEvents();
		SDLMain::updateScreen();
		SDLMain::clearScreen( 0,0,0 );

    for (i = 0; i < NUMBER_OF_STARS; i++)
	{
	  stars[i].zpos -= stars[i].speed;
	  
	  if (stars[i].zpos <= 0)
	    {
	      init_star(stars + i, i + 1);
	    }

	  // compute 3D position
	  tempx = (stars[i].xpos / stars[i].zpos) + centerx;
	  tempy = (stars[i].ypos / stars[i].zpos) + centery;

	  if (tempx < 0 || tempx > (SDLMain::getScreenWidth()) - 1 || tempy < 0 || tempy > (SDLMain::getScreenHeight()) - 1) // check if a star leaves the screen
	    {
	      init_star(stars + i, i + 1);
	      continue;
	    }
	  
		//sphere->display(tempx,tempy);
		sphereSizes[stars[i].zpos]->display(tempx,tempy);
	}
		
		dispatchQueuedMessages();
		mDiffTime = SDL_GetTicks() - mCurrentTime;
		mGameTime += mDiffTime;
		{
			int frameRate = 1/(float (mDiffTime/1000.0f));
			rate = rate + frameRate;
			count++;

			char text[1000];
			sprintf(text, "FrameRate: %i  ", rate/count);
			mFont->putString(0, 412, text);

			frameRate = (float (mGameTime/1.0f));
			sprintf(text, "GameTime: %i          ", frameRate);
			// mFont->setSolid(true);
			mFont->putString(0, 424, text);
		}
		
		if (mInitCount)
		{
			count = 0;
			rate = 0;
			mInitCount--;
			mSecPerFrame += (float (mDiffTime/1000.0f));
			int frameRate = 1/(float (mDiffTime/1000.0f));

			if (mInitCount == 0)
			{
				mSecPerFrame = (float) (mSecPerFrame / ((float)INIT_COUNT));
				for (int i=0; i < mWorldCount; i++)
				{
					mWorld[i]->setSecPerFrame(mSecPerFrame);
				}
				char text[1000];
				sprintf(text, "SecPerFrame: %f  ", mSecPerFrame);
				//mFont->setSolid(true);
				print(0, 400, text);
			}
		}
	}

	
	delete[] (sphereSizes);
	mQuit = false;	
	
  LOG_EXIT 
}


const int SCALED_COMBOBOX_ID = 1;
const int SCALE_FACTOR = 2;
PacmanConfigWindow::PacmanConfigWindow(PacmanGame *game)
	: CSWindow(200, 400)
{
	mGame = game;
	setTitle("Pacman Configuration");
	mTextfield =  new CSTextfield(100);
	mTextfield->addMessageListener(this, GUI_MESSAGE);
	mTextfield->setTooltipText("Enter Scalefactor for tracker... (be reasonable...)");
	mTextfield->setActionId(SCALE_FACTOR);
	mTextfield->setEnabled(true);

	mCombobox =  new CSCombobox(200);
	mCombobox->addMessageListener(this, GUI_MESSAGE);
	mCombobox->setActionId(SCALED_COMBOBOX_ID);
	mCombobox->setEditable(false);
	mCombobox->setEnabled(true);
	mCombobox->setTooltipText("Select the sprite to be tracked...");

	addElement(mCombobox, 10, 30);
	addElement(mTextfield, 10, 10);
}

void PacmanConfigWindow::fillData()
{
	CSStringlist list;

	bool sprites = true;
	if (mGame != 0) 
	{
		if (mGame->mMainSprite != 0) 
		{
			list.add(mGame->mMainSprite->getId(), mGame->mMainSprite);
			CSSprites::iterator iter = mGame->mSprites.begin();
			while (iter != mGame->mSprites.end())
			{
				CSSprite *sprite = *iter;
				if (sprite->getSpriteType() == GHOST_TYPE)
				{
					list.add(sprite->getId(), sprite);
				}
				iter++;
			}
			mCombobox->setItems(list);
			mCombobox->setSelected(mGame->mScaleCenterSprite->getId());
		}
	}
	
	char helper[10];
	sprintf(helper, "%2.2f", mGame->mScaleFactor);
	mTextfield->setText(helper);
}

void PacmanConfigWindow::setVisible(bool v) 
{
	if (v)
	{
		fillData();
	}
	mVisible = v;
}

void PacmanConfigWindow::reactOnMessage(CSMessage *message)
{
	reactOnMessagePacmanConfigWindow(message);
}

void PacmanConfigWindow::reactOnMessagePacmanConfigWindow(CSMessage *message)
{
	static char *functionName="reactOnMessage";
	if (message->mIsHandled)
	{
		reactOnMessageWindow(message);
		return;
	}
	if (message->getType() == GUI_MESSAGE)
	{
		GuiMessage *gm = (GuiMessage *) message;
		if (gm->getSubtype() == COMBOBOX_ITEM_SELECTED_MESSAGE)
		{
			if (gm->actionId == SCALED_COMBOBOX_ID)
			{
				CSSprite *sprite = (CSSprite *) mCombobox->getSelectedObject();
				mGame->mScaleCenterSprite = sprite;
				mGame->mCurrentWorld->displayScaled(mGame->mScaleCenterSprite);
				mGame->mScaleCenterSpriteId = mGame->mScaleCenterSprite->getId();
				gm->mIsHandled = true;
			}
		}
		if (gm->getSubtype() == TEXT_CHANGED_MESSAGE)
		{
			if (gm->actionId == SCALE_FACTOR)
			{
				std::string text = mTextfield->getText();
				mGame->mScaleFactor = atof( text.c_str() );
				char helper[10];
				sprintf(helper, "%2.2f", mGame->mScaleFactor);
				mTextfield->setText(helper);
				mGame->mCurrentWorld->setScaleFactor(mGame->getScaleFactor());
				gm->mIsHandled = true;
			}

		}
	}
	reactOnMessageWindow(message);
}

