#ifdef WIN32
#pragma warning(disable : 4786 )
#endif

#include "PacmanNavigator.h"
#include "CSPicture.h"
#include "CSSprite.h"
#include "CSGame.h"

const char *PacmanNavigator::CLASS = "PacmanNavigator";

PacmanNavigator::PacmanNavigator()
{
	static char *functionName="PacmanNavigator";
	LOG_ENTER 
	LOG_EXIT 
}

PacmanNavigator::~PacmanNavigator()
{
	static char *functionName="~PacmanNavigator";
	LOG_ENTER 
	LOG_EXIT
}

void PacmanNavigator::deinit()
{
	static char *functionName="deinit";
	LOG_ENTER 
	mGame->removeMessageListener(this, INPUT_MESSAGE);
	LOG_EXIT
}

void PacmanNavigator::init()
{
	static char *functionName="init";
	LOG_ENTER 
	mGame->addMessageListener(this, INPUT_MESSAGE);
	reset();
	LOG_EXIT
}

bool PacmanNavigator::preNavigate(CSDisplayParams *displayParams)
{
	static char *functionName="preNavigate";
	return true;
}

void PacmanNavigator::reactOnMessage(CSMessage *message)
{
	static char *functionName="reactOnMessage";
	if (message->getType() == INPUT_MESSAGE)
	{
		switch (message->getSubtype())
		{
			case KEY_UP_MESSAGE:
			{
				mNextDirection = NAV_NORTH;
				break;
			}
			case KEY_DOWN_MESSAGE:
			{
				mNextDirection = NAV_SOUTH;
				break;
			}
			case KEY_RIGHT_MESSAGE:
			{
				mNextDirection = NAV_EAST;
				break;
			}
			case KEY_LEFT_MESSAGE:
			{
				mNextDirection = NAV_WEST;
				break;
			}
			case KEY_FIRE_MESSAGE:
			{
				mSprite->dispatchMessage(&mGame->MESSAGE_FIRE);
				break;
			}
		}
	}
}

