#ifndef PACMANNAVIGATOR_H
#define PACMANNAVIGATOR_H

#include "MazeNavigator.h"
#include "CSMessageListener.h"

#include "CSSprite.h"
#include "CSLog.h"


class PacmanNavigator : public MazeNavigator, CSMessageListener
{
	private:
		std::vector<CSSprite*> mEnemies;
	public:
		PacmanNavigator();
		~PacmanNavigator();
		static const char *CLASS;
		virtual std::string getType() {return (std::string) CLASS;}
		virtual bool preNavigate(CSDisplayParams *displayParams);
		virtual void reactOnMessage(CSMessage *message);
		virtual void addEnemy(CSSprite *sprite)
		{
			mEnemies.push_back(sprite);
		}

		virtual void removeEnemy(CSSprite *sprite)
		{
			CSSprites::iterator iter = mEnemies.begin();
			while (iter != mEnemies.end())
			{
				if (sprite == *iter)
				{
					mEnemies.erase(iter);
					iter = mEnemies.begin();	// restart!
				}
				else
				{
					iter++;
				}
			}
		}
		void init();
		void deinit();
};

#endif // PACMANNAVIGATOR_H
